from asdl import pybase

option_t = int  # type alias for integer

class option_i(object):
  errexit = 1
  nounset = 2
  pipefail = 3
  noexec = 4
  xtrace = 5
  verbose = 6
  noglob = 7
  noclobber = 8
  posix = 9
  vi = 10
  emacs = 11
  interactive = 12
  hashall = 13
  failglob = 14
  extglob = 15
  eval_unsafe_arith = 16
  parse_dynamic_arith = 17
  compat_array = 18
  verbose_errexit = 19
  allow_command_sub = 20
  dynamic_scope = 21
  redefine_module = 22
  _running_trap = 23
  nullglob = 24
  inherit_errexit = 25
  strict_argv = 26
  strict_arith = 27
  strict_array = 28
  strict_control_flow = 29
  strict_errexit = 30
  strict_nameref = 31
  strict_word_eval = 32
  strict_tilde = 33
  strict_glob = 34
  parse_at = 35
  parse_brace = 36
  parse_paren = 37
  parse_raw_string = 38
  parse_triple_quote = 39
  parse_triple_dot = 40
  simple_word_eval = 41
  dashglob = 42
  expand_aliases = 43
  command_sub_errexit = 44
  process_sub_fail = 45
  xtrace_rich = 46
  xtrace_details = 47
  sigpipe_status_ok = 48
  redefine_proc = 49
  parse_equals = 50
  parse_at_all = 51
  parse_backslash = 52
  parse_backticks = 53
  parse_dollar = 54
  parse_ignored = 55
  parse_amp = 56
  simple_echo = 57
  simple_eval_builtin = 58
  simple_test_builtin = 59
  parse_tea = 60
  lastpipe = 61
  progcomp = 62
  histappend = 63
  hostcomplete = 64
  cmdhist = 65
  assoc_expand_once = 66
  autocd = 67
  cdable_vars = 68
  cdspell = 69
  checkhash = 70
  checkjobs = 71
  checkwinsize = 72
  complete_fullquote = 73
  direxpand = 74
  dirspell = 75
  dotglob = 76
  execfail = 77
  extdebug = 78
  extquote = 79
  force_fignore = 80
  globasciiranges = 81
  globstar = 82
  gnu_errfmt = 83
  histreedit = 84
  histverify = 85
  huponexit = 86
  interactive_comments = 87
  lithist = 88
  localvar_inherit = 89
  localvar_unset = 90
  login_shell = 91
  mailwarn = 92
  no_empty_cmd_completion = 93
  nocaseglob = 94
  nocasematch = 95
  progcomp_alias = 96
  promptvars = 97
  restricted_shell = 98
  shift_verbose = 99
  sourcepath = 100
  xpg_echo = 101
  ARRAY_SIZE = 102

_option_str = {
  1: 'option.errexit',
  2: 'option.nounset',
  3: 'option.pipefail',
  4: 'option.noexec',
  5: 'option.xtrace',
  6: 'option.verbose',
  7: 'option.noglob',
  8: 'option.noclobber',
  9: 'option.posix',
  10: 'option.vi',
  11: 'option.emacs',
  12: 'option.interactive',
  13: 'option.hashall',
  14: 'option.failglob',
  15: 'option.extglob',
  16: 'option.eval_unsafe_arith',
  17: 'option.parse_dynamic_arith',
  18: 'option.compat_array',
  19: 'option.verbose_errexit',
  20: 'option.allow_command_sub',
  21: 'option.dynamic_scope',
  22: 'option.redefine_module',
  23: 'option._running_trap',
  24: 'option.nullglob',
  25: 'option.inherit_errexit',
  26: 'option.strict_argv',
  27: 'option.strict_arith',
  28: 'option.strict_array',
  29: 'option.strict_control_flow',
  30: 'option.strict_errexit',
  31: 'option.strict_nameref',
  32: 'option.strict_word_eval',
  33: 'option.strict_tilde',
  34: 'option.strict_glob',
  35: 'option.parse_at',
  36: 'option.parse_brace',
  37: 'option.parse_paren',
  38: 'option.parse_raw_string',
  39: 'option.parse_triple_quote',
  40: 'option.parse_triple_dot',
  41: 'option.simple_word_eval',
  42: 'option.dashglob',
  43: 'option.expand_aliases',
  44: 'option.command_sub_errexit',
  45: 'option.process_sub_fail',
  46: 'option.xtrace_rich',
  47: 'option.xtrace_details',
  48: 'option.sigpipe_status_ok',
  49: 'option.redefine_proc',
  50: 'option.parse_equals',
  51: 'option.parse_at_all',
  52: 'option.parse_backslash',
  53: 'option.parse_backticks',
  54: 'option.parse_dollar',
  55: 'option.parse_ignored',
  56: 'option.parse_amp',
  57: 'option.simple_echo',
  58: 'option.simple_eval_builtin',
  59: 'option.simple_test_builtin',
  60: 'option.parse_tea',
  61: 'option.lastpipe',
  62: 'option.progcomp',
  63: 'option.histappend',
  64: 'option.hostcomplete',
  65: 'option.cmdhist',
  66: 'option.assoc_expand_once',
  67: 'option.autocd',
  68: 'option.cdable_vars',
  69: 'option.cdspell',
  70: 'option.checkhash',
  71: 'option.checkjobs',
  72: 'option.checkwinsize',
  73: 'option.complete_fullquote',
  74: 'option.direxpand',
  75: 'option.dirspell',
  76: 'option.dotglob',
  77: 'option.execfail',
  78: 'option.extdebug',
  79: 'option.extquote',
  80: 'option.force_fignore',
  81: 'option.globasciiranges',
  82: 'option.globstar',
  83: 'option.gnu_errfmt',
  84: 'option.histreedit',
  85: 'option.histverify',
  86: 'option.huponexit',
  87: 'option.interactive_comments',
  88: 'option.lithist',
  89: 'option.localvar_inherit',
  90: 'option.localvar_unset',
  91: 'option.login_shell',
  92: 'option.mailwarn',
  93: 'option.no_empty_cmd_completion',
  94: 'option.nocaseglob',
  95: 'option.nocasematch',
  96: 'option.progcomp_alias',
  97: 'option.promptvars',
  98: 'option.restricted_shell',
  99: 'option.shift_verbose',
  100: 'option.sourcepath',
  101: 'option.xpg_echo',
}

def option_str(val):
  # type: (option_t) -> str
  return _option_str[val]

builtin_t = int  # type alias for integer

class builtin_i(object):
  colon = 1
  dot = 2
  exec_ = 3
  eval = 4
  set = 5
  shift = 6
  times = 7
  trap = 8
  unset = 9
  builtin = 10
  readonly = 11
  local = 12
  declare = 13
  typeset = 14
  export_ = 15
  test = 16
  bracket = 17
  true_ = 18
  false_ = 19
  try_ = 20
  read = 21
  echo = 22
  printf = 23
  mapfile = 24
  readarray = 25
  cd = 26
  pushd = 27
  popd = 28
  dirs = 29
  pwd = 30
  source = 31
  umask = 32
  wait = 33
  jobs = 34
  fg = 35
  bg = 36
  shopt = 37
  complete = 38
  compgen = 39
  compopt = 40
  compadjust = 41
  getopts = 42
  command = 43
  type = 44
  hash = 45
  help = 46
  history = 47
  alias = 48
  unalias = 49
  bind = 50
  append = 51
  shvar = 52
  write = 53
  json = 54
  pp = 55
  module = 56
  use = 57
  argparse = 58
  fopen = 59
  fork = 60
  forkwait = 61
  runproc = 62
  push_registers = 63
  cat = 64
  ARRAY_SIZE = 65

_builtin_str = {
  1: 'builtin.colon',
  2: 'builtin.dot',
  3: 'builtin.exec_',
  4: 'builtin.eval',
  5: 'builtin.set',
  6: 'builtin.shift',
  7: 'builtin.times',
  8: 'builtin.trap',
  9: 'builtin.unset',
  10: 'builtin.builtin',
  11: 'builtin.readonly',
  12: 'builtin.local',
  13: 'builtin.declare',
  14: 'builtin.typeset',
  15: 'builtin.export_',
  16: 'builtin.test',
  17: 'builtin.bracket',
  18: 'builtin.true_',
  19: 'builtin.false_',
  20: 'builtin.try_',
  21: 'builtin.read',
  22: 'builtin.echo',
  23: 'builtin.printf',
  24: 'builtin.mapfile',
  25: 'builtin.readarray',
  26: 'builtin.cd',
  27: 'builtin.pushd',
  28: 'builtin.popd',
  29: 'builtin.dirs',
  30: 'builtin.pwd',
  31: 'builtin.source',
  32: 'builtin.umask',
  33: 'builtin.wait',
  34: 'builtin.jobs',
  35: 'builtin.fg',
  36: 'builtin.bg',
  37: 'builtin.shopt',
  38: 'builtin.complete',
  39: 'builtin.compgen',
  40: 'builtin.compopt',
  41: 'builtin.compadjust',
  42: 'builtin.getopts',
  43: 'builtin.command',
  44: 'builtin.type',
  45: 'builtin.hash',
  46: 'builtin.help',
  47: 'builtin.history',
  48: 'builtin.alias',
  49: 'builtin.unalias',
  50: 'builtin.bind',
  51: 'builtin.append',
  52: 'builtin.shvar',
  53: 'builtin.write',
  54: 'builtin.json',
  55: 'builtin.pp',
  56: 'builtin.module',
  57: 'builtin.use',
  58: 'builtin.argparse',
  59: 'builtin.fopen',
  60: 'builtin.fork',
  61: 'builtin.forkwait',
  62: 'builtin.runproc',
  63: 'builtin.push_registers',
  64: 'builtin.cat',
}

def builtin_str(val):
  # type: (builtin_t) -> str
  return _builtin_str[val]

